package dev.shadowsoffire.apotheosis.ench.enchantments.masterwork;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.ChainsawEnchant;
import dev.shadowsoffire.apotheosis.util.BlockUtil;
import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
import java.util.ArrayDeque;
import java.util.Queue;
import java.util.UUID;
import java.util.function.BooleanSupplier;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.tags.BlockTags;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;

class ChainsawTask implements BooleanSupplier {
  UUID owner;
  
  ItemStack axe;
  
  ServerLevel level;
  
  Int2ObjectMap<Queue<BlockPos>> hits = (Int2ObjectMap<Queue<BlockPos>>)new Int2ObjectOpenHashMap();
  
  int ticks = 0;
  
  public ChainsawTask(UUID owner, ItemStack axe, Level level, BlockPos pos) {
    this.owner = owner;
    this.axe = axe;
    this.level = (ServerLevel)level;
    ((Queue<BlockPos>)this.hits.computeIfAbsent(pos.m_123342_(), i -> new ArrayDeque())).add(pos);
  }
  
  public boolean getAsBoolean() {
    if (++this.ticks % 2 != 0)
      return false; 
    if (this.axe.m_41619_())
      return true; 
    int minY = this.hits.keySet().intStream().min().getAsInt();
    Queue<BlockPos> queue = (Queue<BlockPos>)this.hits.get(minY);
    int breaks = 0;
    while (!queue.isEmpty()) {
      BlockPos pos = queue.poll();
      for (BlockPos p : BlockPos.m_121940_(pos.m_7918_(-1, 0, -1), pos.m_7918_(1, 1, 1))) {
        if (p.equals(pos))
          continue; 
        BlockState state = this.level.m_8055_(p);
        if (state.m_204336_(BlockTags.f_13106_)) {
          BlockUtil.breakExtraBlock(this.level, p, this.axe, this.owner);
          if (!this.level.m_8055_(p).m_204336_(BlockTags.f_13106_)) {
            ((Queue<BlockPos>)this.hits.computeIfAbsent(p.m_123342_(), i -> new ArrayDeque())).add(p.m_7949_());
            breaks++;
          } 
        } 
      } 
      if (breaks > 5)
        break; 
    } 
    if (queue.isEmpty())
      this.hits.remove(minY); 
    return this.hits.isEmpty();
  }
}
